#ifndef SDK_DL_H
#define SDK_DL_H

#include <typedefs.h>
#include <time_date.h>
#include <java.h>

#ifdef __cplusplus
extern "C" {
#endif

#define KEY_0       	0
#define KEY_1       	1
#define KEY_2       	2
#define KEY_3       	3
#define KEY_4       	4
#define KEY_5       	5
#define KEY_6       	6
#define KEY_7       	7
#define KEY_8       	8
#define KEY_9       	9
#define KEY_STAR    	10
#define KEY_POUND   	11

#define KEY_RED     	17
#define KEY_GREEN   	18

#define KEY_LSOFT   	14 
#define KEY_RSOFT   	15 
#define KEY_MENU    	20

#define KEY_SMART   	21

#define KEY_VOLUP   	23
#define KEY_VOLDOWN 	24

#define KEY_UP      	44
#define KEY_DOWN    	45
#define KEY_LEFT    	46
#define KEY_RIGHT   	47
#define KEY_CENTER  	61 

#define KEY_CAM    		0x3F

#define KEY_VOICE   	0x2B
#define KEY_HANDSFREE   0x33
#define KEY_ITUNES 		0x42


/******************************
    
*******************************/

/*    
	E398 ONLY! */
void HAPI_LP393X_disp_backlight_intensity( UINT32 light ); // light = 0..100

/*     
	E398 ONLY! */
void HAPI_LP393X_set_tri_color_led( UINT32 type, //  0-, 1-;
									UINT32 val  //  0xRGB (0x000 - 0xFFF),  0x00F - 
								   );

typedef struct {
    unsigned int *addr;
    unsigned int  data;
    unsigned int  mask;
    UINT8  		    rw;
    UINT8 		   reg;
} HAPI_CAP_ACCESS;

// 
void HAPI_PCAP_transceive(HAPI_CAP_ACCESS*);

/*  (funlight)   fl_id

	 E398 ONLY! */
UINT32 DL_AudStartFunlight( UINT8 fl_id,  UINT32 p2,  UINT32 p3 ); // p2 = 1, p3 = 0

/*  (funlight)   fl_id 
	E398 ONLY! */
UINT32 DL_AudStopFunlight( UINT8 fl_id );

/*   */
void DAL_DisableDisplay( UINT32 p1 ); // p1 = 0

/*   */
void DAL_EnableDisplay( UINT32 p1 ); // p1 = 0

//   .
UINT8 HAPI_ATOD_convert_ambient_light_sensor( void );

//  
void DL_KeyUpdateKeypadBacklight( UINT8 P1 ); // P1 = 1 lighting; P2 = 0

//   
UINT32 UIS_SetBacklightWithIntensity( UINT8 color, // = 255 
									  UINT8 intensity // = 0...6
									); 

/******************************
   DbFeature
******************************/

//   4a  
extern const UINT32 *BEGIN_4A__IN_DB;

#define ID_KEYPAD_LOCK_79              0x86A 
#define ID_KEYPAD_LOCK_49              0x7F3 
#define ID_WORKING_TABLE_49			   0x7F8

//  
UINT8 DL_DbFeatureGetCurrentState( UINT16 fstate_ID, UINT8 *state );
//  
UINT8 DL_DbFeatureStoreState(UINT16 fstate_ID, UINT8 state);

//  : 1 - . 0 - 
extern const UINT32 *KEYPAD_STATE;
#define DB_FEATURE_KEYPAD_STATE		*KEYPAD_STATE


UINT8 DL_DbFeatureGetValue(UINT16 feature_id, UINT32 *feature_value );

UINT8 DL_DbFeatureGetValueString(UINT32 feature_id, WCHAR *feature_string );

//     IMEI
extern const UINT32 *SEEM_IMEI;
#define DB_FEATURE_IMEI				*SEEM_IMEI

//     IMSI
extern const UINT32 *SEEM_IMSI;
#define DB_FEATURE_IMSI				*SEEM_IMSI

/*************************
  
*************************/

typedef struct {
  UINT16   seem_element_id;
  UINT16   seem_record_number;
  UINT32   seem_offset;
  UINT32   seem_size;
} SEEM_ELEMENT_DATA_CONTROL_T; 


//   
UINT16   SEEM_ELEMENT_DATA_read 	( 	SEEM_ELEMENT_DATA_CONTROL_T  *data_ctrl_ptr, //    ,    
										UINT8  *data_buf, //   ,   
										BOOL read_zero_byte_allowed  //  true,     ,    255
									);

//    												
UINT16  SEEM_ELEMENT_DATA_write	(  	SEEM_ELEMENT_DATA_CONTROL_T  *data_ctrl_ptr,
									UINT8  *seem_data_ptr //   ,    
								);	
								
//    							
UINT32 SEEM_GET_ADDRESS_LENGTH_element_length(UINT16 seem_element_id);
//  - records () 
UINT16 SEEM_MAX_RECORD_get_max_record(UINT16 seem_element_id);



/*    seem_data count   seem,  record
	      count  ! */
UINT32 SEEM_FDI_OUTSIDE_SEEM_ACCESS_read( UINT32 seem,  UINT32 record,  void* seem_data,  UINT32 count );

/*    seem_data count    seem,  record
	  */
#define SEEM_WRITE_METHOD_ADD				0
#define SEEM_WRITE_METHOD_UPDATE			1
UINT32 SEEM_FDI_OUTSIDE_SEEM_ACCESS_write( UINT32 method,  UINT32 seem,  UINT32 record,  void* seem_data,  UINT32 count );
													
													
/****************************
   
*****************************/													
/*   */
void HAPI_WATCHDOG_soft_reset( void );

/*   */
void pu_main_powerdown(UINT32 r0);


/****************************
   
****************************/

enum // volume_type
{
    BASE = 0,	//  

    PHONE, //  
    VOICE, //    LTE
    MICROPHONE, //  
    MULTIMEDIA, //    LTE2  V3i
    PTT_TONES,
    MUTABLE_MAX,
    IMMUTABLE_MAX,
    MAX = IMMUTABLE_MAX
};

//  
void DL_AudSetVolumeSetting(UINT8 volume_type, UINT8 volume);
//   
void DL_AudGetVolumeSetting(UINT8 volume_type, UINT8 *volume);


/****************************
  
****************************/

#define MAX_CALLS                   7

typedef struct
{       
    UINT16            call_id;  
    UINT8             call_state;
} CALL_ID_T;

typedef struct
{
    UINT8  		number_of_calls;
    UINT8 		overall_call_state;
    CALL_ID_T 	call_state_info[MAX_CALLS];
} CALL_STATES_T;


//  number_of_calls == 0,   
void DL_SigCallGetCallStates(CALL_STATES_T *call_states);

// TRUE -  (/)
BOOL APP_MMC_Util_IsVoiceCall(void); //  FALSE,   

BOOL AlmclkReminderUtilCallInProgress(void); //  FALSE,     



/********************************
  
*********************************/
//  !

//   
#define EV_SHORTCUT_READ_RECORD                0x820F7 //   SHORTCUT_READ_RECORD_T
//   URL 
#define EV_SHORTCUT_READ_URL	               0x82112 //    SHORTCUT_READ_URL_T

#define SC_TYPE_URL		5
#define SC_TYPE_APP		6

#define SC_TEXT_LEN				  16
#define S_MAX_NUMBER             100
#define SC_ALL_RECORD             0xFE
#define SC_INVALID_RECORD         0xFF

typedef UINT8 SC_TYPE_T;

typedef struct
{
    UINT8            	seem_rec;    // seem_rec-1
    SC_TYPE_T			type;        //   
    UINT8            	index;       //   ,   1.  
    UINT8            	unk1;        // 0xFE
    UINT32            	ev_code;
    UINT32            	list1_index;	 // id   
    UINT32            	param1;       
	UINT32            	list2_index; //  - id 
    UINT32            	param2;       
    INT32            	data;	     //     ,    URL- 
    UINT32		        lang_text;   // RESOURCE_ID
    WCHAR            	text[SC_TEXT_LEN+1];	 //  
    UINT16            	unk2;        // 0xffbd
    
} SEEM_0002_T;

typedef struct {
    UINT8            type;
    UINT32            param1;
    UINT32            list1_index;
    UINT32            param2;
    UINT32            list2_index;
    WCHAR            text[SC_TEXT_LEN+1]; // 0x22 = 34
    UINT32            lang_text;
} SHORTCUT_CREATE_T; // 0x3c = 60


typedef struct 
{
    UINT8       	result; // 0 -  
    UINT8       	unk0;
    SEEM_0002_T 	*record;
} SHORTCUT_READ_RECORD_T;

typedef struct 
{ 
    UINT8  			result; 
    UINT16          url_strlen;
    UINT8		    url[100];
} SHORTCUT_READ_URL_T;


//  									
UINT8 DL_DbShortcutCreateRecord( IFACE_DATA_T  *data, SEEM_0002_T  record );

//  
UINT8 DL_DbShortcutUpdateRecord( IFACE_DATA_T  *data, SEEM_0002_T  record );

//  
UINT8 DL_DbShortcutDeleteRecord( IFACE_DATA_T  *data, UINT8 seem_rec);

//  .  .  EV_SHORTCUT_READ_RECORD.  aatchment   SHORTCUT_READ_RECORD_T
UINT8 DL_DbShortcutGetRecordByRecordId( IFACE_DATA_T  *data, UINT8  seem_rec);

//  -  
UINT16 DL_DbShortcutGetNumOfRecordsAvailable( void ); 

//  -  
UINT16 DL_DbShortcutGetNumOfRecordsUsed( BOOL voice_shortcut );

// DL_DbShortcutIsNumberAvailable //  ?
//   
UINT8 DL_DbGetFirstAvailableNumber( void ); 

//  -    URL
UINT16 DL_DbShortcutGetNumOfURLRecordsUsed( void );

//  -   URL
UINT16 DL_DbShortcutGetNumOfURLRecordsAvailable( void );

//  URL.  .  EV_SHORTCUT_READ_URL
UINT32 DL_DbShortcutGetURLByURLId( IFACE_DATA_T *data, UINT32 URLId);

//   
SC_TYPE_T DL_DbShortcutGetshortcutType( UINT8 index );

//  
UINT32 APP_UtilShortcutCreateAppShortcut ( EVENT_STACK_T *ev_st,  void *app, UINT32 event_code );


/********************************
  
********************************/


//       
#define EV_PHONEBOOK_READ_RECORD	0x82052

typedef struct {
	UINT8  result;       //  . 0 -  .
    UINT8  list_type;    //  
    UINT8  sort_type;    //  
    UINT8  count_items;  //  -   buf
    UINT8  buf[0x4000];  //   
} PHONEBOOK_READ_RECORD_T;

//  
typedef struct {
    UINT16 index; //  
    WCHAR  name[25]; // 
    WCHAR  number[51]; // 
	UINT8  pad[383];
} PHONEBOOK_RECORD_T; // 0x21C

//  
typedef struct {
   WCHAR name[25];
   UINT8 id;
   UINT8 index;
   UINT8 pad[6];
} PHONEBOOK_CATEGORY_RECORD_T; // 0x3A

typedef enum {
    PHONEBOOK_DEVICE_PHONE,
    PHONEBOOK_DEVICE_SIM,
    PHONEBOOK_DEVICE_ALL
} PHONEBOOK_DEVICE_T;

//    .   EV_PHONEBOOK_READ_RECORD
UINT32 DL_DbPhoneBookGetRecordByIndex ( IFACE_DATA_T *data,
										UINT8 list_type, // 0 - 
										UINT16 index, //  
										UINT8 count_items,
										UINT8 sort_type ); 
//    										
UINT32 DL_DbPhoneBookFindRecordByName ( UINT8 list_type,
										WCHAR *name, 
										UINT8 sort_type,
										UINT16 *index );
										
//      .   EV_PHONEBOOK_READ_RECORD
UINT32 DL_DbPhoneBookFindRecordByTelno ( IFACE_DATA_T *data, 
										 UINT8 list_type,
										 WCHAR *tel_number, 
										 UINT8 sort_type );
// -  										 
UINT32 DL_DbPhoneBookGetNumberRecords ( UINT8 list_type,
                                        PHONEBOOK_DEVICE_T device, 
								        UINT16 *count_numbers);
// -  
UINT32 DL_DbPhoneBookGetUsedRecords ( UINT8 list_type,
									  PHONEBOOK_DEVICE_T device, 
									  UINT16 *count_numbers,
                                      UINT8 sort_type );
// -  
UINT32 DL_DbPhoneBookGetAvailableRecords ( UINT8 list_type,
                                           PHONEBOOK_DEVICE_T device, 
										   UINT16 *count_numbers);

//  										   
UINT32 DL_DbPhoneBookDeleteRecordByIndex ( IFACE_DATA_T *iface_data, 
										   UINT8 list_type,
                                           UINT16 index, 
										   UINT8 sort_type );
//   										   
UINT32 DL_DbPhoneBookDeleteAllRecords ( IFACE_DATA_T *iface_data, UINT8 list_type);

//  
UINT32 DL_DbPhoneBookUpdateRecord ( IFACE_DATA_T *iface_data, 
							        UINT8 list_type,
									void * record, 
									UINT8 sort_type );
//  
UINT32 DL_DbPhoneBookStoreRecord ( IFACE_DATA_T *iface_data, 
								   UINT8 list_type,
                                   void * record, 
								   UINT8 sort_type );
//  - 								   
UINT32 DL_DbPhoneBookGetNumberofCategories( UINT8 list_type,
											PHONEBOOK_DEVICE_T device,
											UINT16 *count_categories );
											
//  .   EV_PHONEBOOK_READ_RECORD										
UINT32 DL_DbPhoneBookGetCategoryRecordByIndex( IFACE_DATA_T *data, 
											   UINT8 list_type,
											   PHONEBOOK_DEVICE_T device,
											   UINT8 category_index );

//  
UINT32 DL_DbPhoneBookStoreCategoryRecord (  IFACE_DATA_T *data,
											UINT8 list_type,
											PHONEBOOK_DEVICE_T device,
											void *category_record, // PHONEBOOK_CATEGORY_RECORD_T
											UINT8 *unk ); //   NULL
//  
UINT32 DL_DbPhoneBookDeleteCategoryRecord(  IFACE_DATA_T *data,
									        UINT8 list_type,
											PHONEBOOK_DEVICE_T device,
											UINT8 category_id );
/********************************
  Web-
********************************/

typedef enum {
    WS_TIMEOUT_NULL = 0,
    WS_TIMEOUT_1_MIN,
    WS_TIMEOUT_2_MIN,
    WS_TIMEOUT_5_MIN,
    WS_TIMEOUT_10_MIN,
    WS_TIMEOUT_15_MIN
} WS_TIMEOUT_T;

typedef struct
{
    WCHAR apn[101];
    WCHAR login[33];
    WCHAR password[17];
} WS_GPRS_RECORD_T;

typedef struct
{
    UINT8  attr;
    WCHAR  session_name[17];
    WCHAR  home_page[101];
    UINT16 ip1[8];
    UINT16 port1;
    WCHAR  domain1[101];
    UINT8  service_type1;
    UINT16 ip2[8];
    UINT16 port2;
    WCHAR  domain2[101];
    UINT8  service_type2;
    UINT16 dns1[8];
    UINT16 dns2[8];
    WS_TIMEOUT_T timeout;
    void * csd_record1;
    void * csd_record2;
    WS_GPRS_RECORD_T * gprs_record;
} WS_RECORD_T;

#define WS_EVENT				0x82143 //   WS_EVENT_T

typedef struct
{
    UINT8 result;
    UINT8 index;
} WS_EVENT_T;


//   Web-   
UINT32 DL_DbWebSessionsGetSessionByIndex(IFACE_DATA_T *iface_data, UINT8 index, WS_RECORD_T *ws_record);

//    Web-
UINT32 DL_DbWebSessionsGetDefaultSessionIndex(UINT8 *index);

//  
UINT32 DL_DbWebSessionsAddSession ( IFACE_DATA_T * iface_data,
									UINT8 device_type, // =0
                                    WS_RECORD_T *ws_record,
									UINT8 unk  // = 0
								   );
//  								   
UINT32 DL_DbWebSessionsDeleteSessionByIndex ( IFACE_DATA_T * iface_data,
											  UINT8 index,
                                              UINT8 unk ); // = 0							   
								   
// -   								   
UINT32 DL_DbWebSessionsGetNumberGoodSessions ( UINT8 device_type, // =0
											   UINT8 * total_num,
											   UINT8 unk ); // = 0

// -  
UINT32 DL_DbWebSessionsGetNumberUsedSessions ( UINT8 device_type, // =0
											   UINT8 * used_num,
											   UINT8 unk ); // = 0
// -  
UINT32 DL_DbWebSessionsGetNumberAvailableSessions ( UINT8 device_type, // =0
												    UINT8 * available_num,
												    UINT8 unk ); // = 0							   

/********************************
   
********************************/		

typedef struct {
    UINT8 index;
    WCHAR name [25];
    CLK_TIME_T time;
    UINT64 alert_tone;
    BOOL is_alarm_enabled;
    UINT8 alarm_id;
    UINT8 ringer_volume;
    BOOL is_wake_up_alarm;
} ALMCLK_RECORD_T;

//  
UINT32 DL_DbAlmclkGetRecordByIndex(UINT8 index, ALMCLK_RECORD_T * record);

//  
UINT32 DL_DbAlmclkCreateRecord(ALMCLK_RECORD_T * record);

//   
UINT32 DL_DbAlmclkDeleteAllRecords(void);
//  
UINT32 DL_DbAlmclkDeleteRecordByIndex(UINT8 index);

/********************************
   
********************************/	

typedef enum {
    DBK_REPEAT_NONE = 0, 		// 
    DBK_REPEAT_DAILY,			//  
    DBK_REPEAT_WEEKLY,			// 
    DBK_REPEAT_MONTHLY_ON_DATE, // .  
    DBK_REPEAT_MONTHLY_ON_DAY,  // .  
    DBK_REPEAT_YEAR 			// 
} DBK_REPEAT_T;


typedef struct
{
    WCHAR           title[65]; // 
    BOOL            timed_event;
    BOOL            alarm_enabled; //  /
    CLK_TIME_T   	start_time; //  
    CLK_DATE_T   	start_date; //   
    UINT32		    duration; // 
    CLK_TIME_T   	alarm_time; //  
    CLK_DATE_T   	alarm_date; //  
    DBK_REPEAT_T    repeat; //  

    JAVA_APP_ID		java_id; // id  
	JAVA_APP_ID		java_suite_id; 
	WCHAR        	java_name[33]; //  -

} DBK_EVENT_DETAILS_T;

typedef struct
{
    UINT32                 event_id; //   
    DBK_EVENT_DETAILS_T    event_details;
} DBK_EVENT_INSTANCE_T;

typedef struct
{
    UINT8   				result;
    DBK_EVENT_INSTANCE_T 	event_instance;
} DBK_DATABASE_RESULT_T;

#define EV_DBK_ADD_EVENT		  	0x8206B //   0x8206E,   DBK_DATABASE_RESULT_T
#define EV_DBK_DATABASE_QUERY 		0x8206C //   DBK_DATABASE_RESULT_T



//      .  ,       .
UINT8 DL_DBK_RegisterApplication(SU_PORT_T su_port);
//  
UINT8 DL_DBK_UnregisterApplication(SU_PORT_T su_port);

//  ,    EV_DBK_ADD_EVENT
UINT8 DL_DBK_AddEventToDatabase(IFACE_DATA_T *iface_data, DBK_EVENT_DETAILS_T *event_details); 
//   
UINT8 DL_DBK_UpdateEventData( IFACE_DATA_T *iface_data, 
							  DBK_EVENT_INSTANCE_T *event_instance
							);
//  
UINT8 DL_DBK_DeleteEventFromDatabase(IFACE_DATA_T    *iface_data,
									 UINT32          event_id,
									 UINT8			 extdelete // 0 - , 1 -    
									);
							   
//         .     EV_DBK_DATABASE_QUERY							   
UINT8 DL_DBK_GetFirstEventInTimeFrame(IFACE_DATA_T  *iface_data,
									  CLK_DATE_T start_date,
									  CLK_TIME_T start_time,
	                                  CLK_DATE_T end_date,
									  CLK_TIME_T end_time
									  );
//   .     EV_DBK_DATABASE_QUERY									  
UINT8 DL_DBK_GetNextEventInTimeFrame(IFACE_DATA_T  *iface_data,
									 UINT32        event_id, //    ?
									 CLK_DATE_T    end_date,
									 CLK_TIME_T    end_time);
//     .     EV_DBK_DATABASE_QUERY									 
UINT8 DL_DBK_GetEventInstanceByIdNumber(IFACE_DATA_T *iface_data, UINT32 event_id);

/********************************
  
********************************/


typedef enum
{
    MSG_FOLDER_INBOX              = 0, //  
    MSG_FOLDER_OUTBOX             = 1, //  
    MSG_FOLDER_INFOSRV_INBOX      = 2,
    MSG_FOLDER_QUICKNOTE          = 3,
    MSG_FOLDER_DRAFTS_FOLDER      = 4,
    MSG_FOLDER_EMAIL_INBOX        = 5,
    MSG_FOLDER_TEMP_FOLDER        = 15,
    MSG_FOLDER_VOICEMAIL          = 16,
    MSG_FOLDER_BROWSER_MSGS       = 19,
    MSG_FOLDER_ALL_FOLDERS        = 23,
    MSG_FOLDER_INVALID            = 255
	
} MSG_FOLDER_T;


#define EV_MSG_READ            0x82068 //   MSG_READ_T

typedef struct
{
	UINT8	pad[0x6c];
	WCHAR	phone_number[0x22];//   
	UINT8	pad2[0x1C8];
	WCHAR	text[0x100]; //  
} MSG_READ_T;

//    id
//      EV_MSG_READ 
UINT8 DL_DbMessageGenericGetMessage(IFACE_DATA_T 	*iface_data, 
									MSG_FOLDER_T 	msg_folder, 
									UINT16  		msg_id,
									UINT16 			part_num, // 0 or 1
									UINT8			unk  // = 0
									);
//   id 									
UINT8 DL_DbMessageGenericGetMessageIDList(MSG_FOLDER_T  msg_folder,
										  UINT16 *total_number,
										  UINT16 *msg_id_list, // c id ,  245
										  UINT8  unk // = 0
										 );


//   											
UINT32 MsgUtilGetUnreadMsgsInAllFolders(UINT16 *msg_total);

//   
typedef struct
{
	WCHAR  address[51];
	UINT8  addr_type; // 0 -SMS, 1 - EMAIL, 2 - No, 3 - Long Msg ??? 
	WCHAR  contents[512]; //   0x7BFE,   SMS, ,  
} SEND_TEXT_MESSAGE_T;

UINT32 DL_SigMsgSendTextMsgReq(IFACE_DATA_T *port, SEND_TEXT_MESSAGE_T *msg_ptr);


/********************************
  USSD  
********************************/
#define USSD_INVALID_SS_ID 0xFFFF
typedef UINT16 USSD_SS_ID_T;

//     -.      ,  
#define EV_USSD_NOTIFY		0x82039 //   USSD_REQUEST_NOTYFY_T

//  USSD-  ,   .    DL_SigCallSSSendUSSDResponseReq   ss_id
#define EV_USSD_REQUEST   	0x8203A //   USSD_REQUEST_NOTYFY_T

// -    .       
#define EV_USSD_COMPLETE  	0x8203B //    USSD_COMPLETE_T

//     DL_SigCallSSOperationReq
#define EV_USSD_OPERATION	0x82028 //   USSD_OPERATION_T

typedef struct
{
    WCHAR str[200];
} USSD_STRING_T;

typedef struct
{
    USSD_SS_ID_T    ss_id;
    USSD_STRING_T   ussd_string;
} USSD_REQUEST_NOTYFY_T;

typedef struct
{
    USSD_SS_ID_T    ss_id;
    UINT8           result;
    UINT8           cause;
    USSD_STRING_T   ussd_string;
} USSD_COMPLETE_T;


typedef struct
{
   USSD_SS_ID_T    ss_id;
   UINT8           result;
   UINT8           cause;
   UINT8           operation;  // = 6
   UINT8           unk[4];        
   UINT8           return_data_type; // = 7
   USSD_STRING_T   return_data;
    //     
} USSD_OPERATION_T; 



typedef struct
{
    WCHAR ss_string[200];
    UINT8 ton; // = 1
    UINT8 npi; // = 1
} USSD_REQ_STRING_T;


//  USSD ,  ss_id
USSD_SS_ID_T DL_SigCallSSOperationReq ( IFACE_DATA_T *iface_data,
                                 USSD_REQ_STRING_T * str,
	                             UINT8 unk // = 0
								);

//   USSD    EV_USSD_REQUEST
void DL_SigCallSSSendUSSDResponseReq (IFACE_DATA_T 			*if_data,
									  USSD_SS_ID_T			id, //  . : 0x0000 - 0xFFFE
									  USSD_STRING_T 		*str //  
									  );
//   USSD									  
void DL_SigCallSSAbortUSSDReq ( USSD_SS_ID_T id );

/********************************
   
********************************/

//  /  seq_num
UINT32 DL_AudPlayTone( UINT32 tone,  UINT8 volume ); //Current volume = 0xFF
//  
void DL_AudStopTone(UINT32 tone, UINT32 seq_num);


//  . 
void DL_KeyInjectKeyPress( UINT8 key_code, 
						   UINT8 states, // 0 - Press; 1 - Release
						   UINT8 p3 // = 0
						  );

//  
UINT32 DL_DbSigNamGetSecurityCode(WCHAR *);
UINT32 DL_DbSigNamGetUnlockCode(WCHAR *);

//  PIN
enum {
	SIMPIN_STATUS_SECURED = 2,	//   
	SIMPIN_STATUS_NO_PIN,
	SIMPIN_STATUS_INVALID
};
UINT8 DL_SimMgrGetPinStatus( UINT8 card );

//   
typedef struct
{
    UINT8 	percent;
    INT8    dbm;
} SIGNAL_STRENGTH_T;

void DL_SigRegQuerySignalStrength(SIGNAL_STRENGTH_T *signal_strength);

// Location Area Identification -   
typedef struct 
{
    UINT16  mcc; // Mobile Country Code -  
    UINT8   mnc; //Mobile Network Code -  
    UINT16  lac; // Location Area Code  -    
} SIG_REG_LAI_T;

void DL_SigRegGetLAI(SIG_REG_LAI_T *lai);

// Cell Id
void DL_SigRegGetCellID(UINT16 *cell_id);

//    
UINT8 DL_PwrGetActiveBatteryPercent( void );

// true -  
BOOL DL_AccIsHeadsetAvailable(void);

//  IMSI
UINT32 DL_DbSigNamGetTrueIMSI( UINT8 unk, // = 0,1,2...
							   WCHAR *imsi );


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif

