#ifndef TIME_DATE_H
#define TIME_DATE_H

#include <typedefs.h>

#ifdef __cplusplus
extern "C" {
#endif

//     
UINT64 suPalReadTime( void ); 
//        
UINT64 suPalTicksToMsec( UINT64 ticks );

typedef struct
{
    UINT8     day;
    UINT8     month;
    UINT16    year;
} CLK_DATE_T;

typedef struct
{
    UINT8     hour;
    UINT8     minute;
    UINT8     second;
} CLK_TIME_T;

//   
BOOL DL_ClkGetDate( CLK_DATE_T * date);
//  
BOOL DL_ClkSetDate( CLK_DATE_T date );
//    
BOOL DL_ClkGetTime( CLK_TIME_T * time);
//  
BOOL DL_ClkSetTime( CLK_TIME_T time );

/***************************************
    Alarm
****************************************/

//  Alarm
#define EV_ALARM_EXPIRED		0x8205A //  (CLK_ALARM_DATA_T*)EVENT_T::attachment

typedef struct
{
    CLK_TIME_T 	time;  
    CLK_DATE_T 	date;  
    UINT32     	unk;  
} DL_ALARM_DATA_T;

//  Alarm
BOOL DL_ClkStoreIndividualEvent( IFACE_DATA_T *data, DL_ALARM_DATA_T alarm_data );

//  Alarm
BOOL DL_ClkDeleteIndividualEvent( IFACE_DATA_T *data, DL_ALARM_DATA_T alarm_data,
								  UINT8 mask ); // 1 - time, 2- date....  63 -  ?


/***************************************
    Timer 
****************************************/

//  
#define EV_TIMER_EXPIRED		  0x8205A // (DL_TIMER_DATA_T*)EVENT_T::attachment

/*   ,    EV_TIMER_EXPIRED, attachment    DL_TIMER_DATA_T */

typedef struct
{
	UINT32		time;
	UINT32		ID;
} DL_TIMER_DATA_T;

/*   ,    time  */
UINT32 APP_UtilStartTimer( UINT32 time,  UINT32 ID,  void *app ); // ID   DL_TIMER_DATA_T   

/*   ,      time  */
UINT32 APP_UtilStartCyclicalTimer( UINT32 time,  UINT32 ID,  void *app );
/*   */
UINT32 APP_UtilStopTimer( void *app );

UINT32 DL_ClkStartTimer( IFACE_DATA_T* iface, UINT32 period, UINT32 id );
UINT32 DL_ClkStartCyclicalTimer( IFACE_DATA_T* iface, UINT32 period, UINT32 id );
UINT32 DL_ClkStopTimer( IFACE_DATA_T* iface );

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif